<template>
  <v-menu
    bottom
    left
    min-width="200"
    offset-y
    origin="top right"
    transition="scale-transition"
  >
    <template v-slot:activator="{ attrs, on }">
      <v-btn
        class="ml-2"
        min-width="0"
        text
        v-bind="attrs"
        v-on="on"
      >
        <v-icon>mdi-account</v-icon>
        <template v-if="isLoading">
          <v-progress-circular
            indeterminate
            size="12"
            width="2"
            color="blue"
          />
        </template>
      </v-btn>
    </template>

    <v-list
      :tile="false"
      flat
      nav
    >
      <template v-for="(p, i) in profile">
        <v-divider
          v-if="p.divider"
          :key="`divider-${i}`"
          class="mb-2 mt-2"
        />

        <app-bar-item
          v-else
          :key="`item-${i}`"
          :to="p.path"
        >
          <template v-if="!p.callback">
            <v-list-item-title v-text="p.title" />
          </template>
          <template v-else>
            <v-list-item-button @click="p.callback()">
              <v-icon>mdi-logout</v-icon>
              <span>{{ p.title }}</span>
            </v-list-item-button>
          </template>
        </app-bar-item>
      </template>
    </v-list>
  </v-menu>
</template>

<script>
  export default {
    name: 'DefaultAccount',
    data () {
      return {
        isLoading: false,
        profile: [
          { title: this.$t('global.routes.Administration'), path: { name: 'Administration' } },
          { divider: true },
          {
            title: this.$t('logout'),
            callback: () => {
              this.isLoading = true
              this.$store.dispatch('auth/logout')
                .then(() => {
                  this.$router.push({
                    name: this.$store.getters['router/defaultPublicRoute'],
                  }).catch(() => {})
                })
                .finally(() => {
                  this.isLoading = false
                })
            },
          },
        ],
      }
    },
    i18n: {
      messages: {
        'pt-BR': {
          logout: 'Sair',
        },
        'en-US': {
          logout: 'Logout',
        },
      },
    },
  }
</script>
